let plus_vec (a,b) (c,d) = (a+c,b+d);;

let minus_vec (a,b) (c,d) = (a-c,b-d);;

let insert_to_list x l =
    if List.mem x l then l
    else (x::l);;

(* no longer used *)
let rec merge_lists l = function
    | [] -> ((0,0)::l) (* (0,0) added to separate winning positions from each iteration *)
    | (hd::tl) -> if List.mem hd l then merge_lists l tl else hd::(merge_lists l tl);;

let rec attr_eve eve set_x =
    match set_x with
    | [] -> []
    | ((x,y)::l) ->
        let accu = ref (attr_eve eve l) in
            for i = 1 to Array.length eve do
                accu := insert_to_list (minus_vec (x,y) eve.(i-1)) !accu
            done;
        !accu;;

let attr_adam adam set_x set_eve =
    let rec attr_adam_rec = function
        | [] -> set_x
        | ((x,y)::l) ->
            let accu = ref (attr_adam_rec l) in
                let candidate = minus_vec (x,y) adam.(0) in
                    if List.mem candidate !accu then !accu else
                        try for i = 2 to Array.length adam do
                            if not (List.mem (plus_vec candidate adam.(i-1)) set_eve)
                                then failwith "Missing"
                        done; failwith "Accepted"
                        with Failure "Accepted" -> insert_to_list candidate !accu;
                        | Failure "Missing" -> !accu
                        | _ -> failwith "Unexpected error"
    in attr_adam_rec set_eve;;

let attr adam eve set_x = (0,0)::(attr_adam adam set_x (attr_eve eve set_x));;
(* (0,0) added to separate winning positions from each iteration *)

let compute adam eve nb_iter =
    let rec pre_n set_x iter =
        match iter with
        | 0 -> set_x
        | n -> pre_n (attr adam eve set_x) (n-1)
    in pre_n [(0,0)] nb_iter;;
